unit Frame;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ComCtrls, StdCtrls, Clipbrd, ShellAPI, PrintTxt, Param, DataList,
  InfoList, RichEdit, ToolBox, FindDialog, ReplaceDialog, CommonMemory,
  ExtCtrls, FileCtrl;

const
  { ̋؂q }
  Separator: set of Byte = [$09, $0A, $0D, $20..$2F, $3A..$3F, $5B..$5D, $7B..$7D];

type
  PUndoData = ^TUndoData;
  { Ctrl+Y, Ctrl+U, Ctrl+W ɂ폜̃AhEׂ̍\ }
  TUndoData = record
    Modified: Boolean;   // 폜钼O RichEdit1.Modified ̒l
    SelStart: Integer;   // 폜钼ÕZʒu
    ReSelStart: Integer; // 폜񕜂鎞̃Zʒu
    SelText: String;     // 폜ꂽ
    CanUndo: Boolean;    // AhE\ǂl
  end;

type
  TFrameForm = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    N1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    SaveAs1: TMenuItem;
    N2: TMenuItem;
    PrintSetup1: TMenuItem;
    Print1: TMenuItem;
    N3: TMenuItem;
    X1: TMenuItem;
    Edit1: TMenuItem;
    Undo1: TMenuItem;
    N4: TMenuItem;
    Cut1: TMenuItem;
    Copy1: TMenuItem;
    P1: TMenuItem;
    Delete1: TMenuItem;
    N5: TMenuItem;
    SelectAll1: TMenuItem;
    D1: TMenuItem;
    N6: TMenuItem;
    W1: TMenuItem;
    Find1: TMenuItem;
    Find2: TMenuItem;
    FindNext1: TMenuItem;
    Help1: TMenuItem;
    SearchforHelpOn1: TMenuItem;
    About1: TMenuItem;
    StatusBar1: TStatusBar;
    OpenDialog1: TOpenDialog;
    FontDialog1: TFontDialog;
    SaveDialog1: TSaveDialog;
    PrinterSetupDialog1: TPrinterSetupDialog;
    N7: TMenuItem;
    N8: TMenuItem;
    T1: TMenuItem;
    D2: TMenuItem;
    J1: TMenuItem;
    Replace1: TMenuItem;
    Option1: TMenuItem;
    N9: TMenuItem;
    N10: TMenuItem;
    N14: TMenuItem;
    F2: TMenuItem;
    PrintPreview1: TMenuItem;
    PrintDialog1: TPrintDialog;
    N12: TMenuItem;
    P3: TMenuItem;
    S1: TMenuItem;
    Parameter1: TParameter;
    InfoList1: TInfoList;
    RichEdit1: TRichEdit;
    C1: TMenuItem;
    D3: TMenuItem;
    N11: TMenuItem;
    FindDialogBox1: TFindDialogBox;
    ReplaceDialogBox1: TReplaceDialogBox;
    I1: TMenuItem;
    N13: TMenuItem;
    Q1: TMenuItem;
    N15: TMenuItem;
    N16: TMenuItem;
    N17: TMenuItem;
    N18: TMenuItem;
    N20: TMenuItem;
    N19: TMenuItem;
    procedure Open1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure F1Click(Sender: TObject);
    procedure X1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure SaveAs1Click(Sender: TObject);
    procedure Print1Click(Sender: TObject);
    procedure PrintSetup1Click(Sender: TObject);
    procedure Edit1Click(Sender: TObject);
    procedure Undo1Click(Sender: TObject);
    procedure Cut1Click(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
    procedure P1Click(Sender: TObject);
    procedure Delete1Click(Sender: TObject);
    procedure SelectAll1Click(Sender: TObject);
    procedure D1Click(Sender: TObject);
    procedure W1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure SearchforHelpOn1Click(Sender: TObject);
    procedure Find2Click(Sender: TObject);
    procedure FindNext1Click(Sender: TObject);
    procedure Find1Click(Sender: TObject);
    procedure N7Click(Sender: TObject);
    procedure T1Click(Sender: TObject);
    procedure D2Click(Sender: TObject);
    procedure J1Click(Sender: TObject);
    procedure Replace1Click(Sender: TObject);
    procedure N9Click(Sender: TObject);
    procedure N10Click(Sender: TObject);
    procedure F2Click(Sender: TObject);
    procedure Option1Click(Sender: TObject);
    procedure PrintPreview1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure P3Click(Sender: TObject);
    procedure S1Click(Sender: TObject);
    procedure C1Click(Sender: TObject);
    procedure D3Click(Sender: TObject);
    procedure N11Click(Sender: TObject);
    procedure RichEdit1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure RichEdit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FindDialogBox1Find(Sender: TObject);
    procedure FindDialogBox1ChangeDivision(Sender: TObject);
    procedure FindDialogBox1ChangeDirection(Sender: TObject);
    procedure FindDialogBox1ChangeFindText(Sender: TObject);
    procedure FindDialogBox1Show(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ReplaceDialogBox1ChangeDirection(Sender: TObject);
    procedure ReplaceDialogBox1ChangeDivision(Sender: TObject);
    procedure ReplaceDialogBox1ChangeFindText(Sender: TObject);
    procedure ReplaceDialogBox1Find(Sender: TObject);
    procedure ReplaceDialogBox1ReplaceFind(Sender: TObject);
    procedure ReplaceDialogBox1ReplaceAll(Sender: TObject);
    procedure ReplaceDialogBox1Show(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure RichEdit1Change(Sender: TObject);
    procedure RichEdit1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure I1Click(Sender: TObject);
    procedure Q1Click(Sender: TObject);
    procedure N15Click(Sender: TObject);
    procedure Help1Click(Sender: TObject);
    procedure N17Click(Sender: TObject);
    procedure N18Click(Sender: TObject);
    procedure N20Click(Sender: TObject);
  private
    { Private 錾 }
    procedure Search(S: String; Down: Boolean);
    function Hook(var Message: TMessage): Boolean;
  public
    { Public 錾 }
    CM: TCommonMemory;     // L
    MatchCase: Boolean;    // 啶ƏʂČ邩ǂ肷XCb`
    Indent: Boolean;       // Cfg()邩ǂ肷XCb`
    FindStr: String;       // 
    FindOption: Boolean;   // ɃJ[\ʒu̕邩ǂ肷XCb`
    FoundPos: Integer;     // 񂪌Ȃꍇ -1 ɃZbgϐ
    OldDown: Boolean;      // 񌟍̒O̕
    OldSel: Integer;       // ݂̃J[\ʒu̒ÕJ[\ʒu
    Jump: String;          // Wv̍sԍ
    TabSize: Integer;      // ^uTCY
    DefaultExt: Boolean;   // t@C̊gqɂă^uTCY肷B
    BackupFileName: String; // OnShow Ō肳obNAbvt@C
    EditMode: Integer;     // ҏW[h
    InsertMode: Boolean;   // }[h
    Modified: Boolean;     // ҏW̃f[^ύXĂ鎖tO
    DownCY: Integer;       // OnKeyDown ̃J[\̍sʒu
    PrintMessage: Word;    // [h͈̎̈͂肷B
    LoadedFileAllData: Boolean; // t@C̑Sf[^[hĂ邩ǂtO
    BCount: Integer;       // f[^̕
    RCount: Integer;       // ŏIIȎۂ̕
    BSize: Integer;        // f[^̕TCY
    RSize: Integer;        // ŏIIȎۂ̕TCY
    BIndex: Integer;       // \̃ubNԍ
    BLines: array of Integer; // eubN̍si[ׂ̔z
    ChangeCount: Integer;  // ύXꂽ
    UD: TUndoData;         // AhEׂ̍\
    function ModifiedCheck: Boolean; // f[^ύXĂ邩ǂԂB
    function BinaryCheck: Boolean;   // oCif[^邩ǂԂB
    procedure DispStatus;
    procedure GetFindStr;
    procedure AcceptFiles(var msg: TMessage); message WM_DROPFILES;
    procedure IdleHandler(Sender: TObject; var Done: Boolean);
    procedure ActivateHandler(Sender: TObject);
    procedure LoadFromFile(FileName: String);
    procedure SaveToFile(FileName: String);
    function RichEditSetTabStops(const TabWidth: Integer): Boolean;
    function RichEditFillTabWidthsForFixedFont(const CharCount: Integer): Boolean;
    procedure SetTabSize(Value: Integer);
    procedure MakeBackupFileName;
    function MakeBackupFile: Boolean;
    procedure DeleteBackupFiles(Undo: Boolean);
    function LineLength: Integer;
    function LineCount: Integer;
    function CX: Integer;
    procedure SetCX(Value: Integer);
    function CY: Integer;
    procedure SetCY(Value: Integer);
    function ReplaceOne(const FindText: String; const ReplaceText: String; MatchCase: Boolean): Boolean;
    function ReplaceAll(const FindText: String; const ReplaceText: String; MatchCase: Boolean): Integer;
    function ReplaceSel(const FindText: String; const ReplaceText: String; MatchCase: Boolean): Integer;
    function GetPrintMessage: Word;
    function SizeOfFile(FileName: String): Integer;
    procedure RemakeData(Index: Integer);
    procedure LoadStream(Stream: TStream);
    procedure LoadFile(FileName: String);
    procedure SaveStream(Stream: TStream);
    procedure SaveFile(FileName: String);
    function GoLastBlock: Boolean;
    function GoNextBlock: Boolean;
    function GetBLines(Index: Integer): Integer;
    function ViewLineCount: Integer;
    function ViewTopLine: Integer;
    procedure SetViewTopLine(Value: Integer);
    function ViewTopSel: Integer;
    procedure SetViewTopSel(Value: Integer);
    function Local2GlobalSel(Sel: Integer): Integer;
    function Global2LocalSel(GSel: Integer): Integer;
    function GlobalSel2Block(GSel: Integer): Integer;
    function GlobalLen: Integer;
    function BlockLen: Integer;
    function IndentStr(Line: Integer): String;
    function Tab2Space(S: String; TabSize: Integer): String;
    function Space2Tab(S: String; TabSize: Integer): String;
  end;

var
  FrameForm: TFrameForm;

implementation

uses Preview, Setting, Key;

{$R *.DFM}

{  S ̃^uXy[XɕϊԂ֐łB}
{ ^ueŃp[^ TabSize ɉ̃Xy[Xɕϊ܂B}
{ ̊֐ S s̏̕ꍇɂΉĂ܂B}

function TFrameForm.Tab2Space(S: String; TabSize: Integer): String;
var
  i, j, k, l, m: Integer;
  Line, Space: String;

  function TabToSpace: String;
  begin
    Result := '';
    i := 1; // `FbN̊Jnʒu
    j := 1; // `FbN̐擪ʒu
    while i <= Length(Line) do
    begin
      if Line[i] = #9 then // ^u
      begin
        Result := Result + Copy(Line, j, i - j);
        Result := Result + Copy(Space, 1, TabSize - (Length(Result) mod TabSize));
        j := i + 1; // ̃`FbN̐擪ʒu
      end;
      Inc(i); // ̃`FbN̊Jnʒu
    end;
    Result := Result + Copy(Line, j, i - j);
  end;

begin
  Result := '';
  if (S = '') or (not (TabSize in [1..32])) then
    Exit;

  Space := '                                '; // 32 ̃Xy[X
  k := 1; // s̐擪ʒu
  while k <= Length(S) do
  begin
    l := k; // ̉sR[h̐擪ʒu߂B
    while (l <= Length(S)) and (not (S[l] in [#13, #10])) do
      Inc(l);
    m := l; // ̍s̐擪ʒu߂B
    while (m <= Length(S)) and (S[m] in [#13, #10]) do
      Inc(m);
    Line := Copy(S, k, l - k);
    Result := Result + TabToSpace + Copy(S, l, m - l);
    k := m;
  end;
end;

{  S ̃Xy[X^uɕϊԂ֐łB }
{ eŃp[^ TabSize ɉ̃Xy[X1̃^uɕϊ }
{ ܂B̊֐ S s̏̕ꍇɂΉĂ܂B}

function TFrameForm.Space2Tab(S: String; TabSize: Integer): String;
var
  i, j, k, l, m: Integer;
  Line, Space: String;

  function SpaceToTab: String;
  begin
    Result := '';
    i := TabSize; // `FbN̊Jnʒu
    j := 1; // `FbN̐擪ʒu
    while (j <= Length(Line)) and (i <= Length(Line)) do
    begin
      while (i >= j) and (Line[i] = ' ') do
        Dec(i);
      Result := Result + Copy(Line, j, i + 1 - j);
      if i < J + TabSize - 1 then
        Result := Result + #9;
      j := j + TabSize; // ̃`FbN̐擪ʒu
      i := j + TabSize - 1; // ̃`FbN̊Jnʒu
    end;
    Result := Result + Copy(Line, j, Length(Line) + 1 - j);
  end;

begin
  Result := '';
  if (S = '') or (not (TabSize in [1..32])) then
    Exit;

  Space := '                                '; // 32 ̃Xy[X
  k := 1; // s̐擪ʒu
  while k <= Length(S) do
  begin
    l := k; // ̉sR[h̐擪ʒu߂B
    while (l <= Length(S)) and (not (S[l] in [#13, #10])) do
      Inc(l);
    m := l; // ̍s̐擪ʒu߂B
    while (m <= Length(S)) and (S[m] in [#13, #10]) do
      Inc(m);
    Line := Copy(S, k, l - k);
    Result := Result + SpaceToTab + Copy(S, l, m - l);
    k := m;
  end;
end;

function TFrameForm.SizeOfFile(FileName: String): Integer;
var
  R: TSearchRec;
begin
  if (FindFirst(FileName, faAnyFile, R) <> 0) or
     ((R.Attr and faDirectory) > 0) then
    Result := -1
  else
    Result := R.Size;
  FindClose(R);
end;

{ ݂ BCount  BSize ̒lɊÂāAf[^č\z葱łB}
{ Index ͍č\zɕ\ubNԍłB}

procedure TFrameForm.RemakeData(Index: Integer);
var
  mf: Boolean;
  ids: Integer;
  Stream: TMemoryStream;
begin
  ModifiedCheck;
  BinaryCheck;
  mf := Modified;
  ids := InfoList1.DataSize;

  Stream := TMemoryStream.Create;
  try
    SaveStream(Stream);
    LoadStream(Stream);
  finally
    Stream.Free;
  end;

  if InfoList1.Count = 0 then
    BIndex := InfoList1.AddText('', '') // ̃f[^Ēu
  else
  begin
    BIndex := Index;
    if BIndex < 0 then
      BIndex := 0
    else if BIndex > RCount - 1 then
      BIndex := RCount - 1;
  end;

  GetBLines(BIndex); // BLines[] Ɋesi[Ă BIndex Ԃ̃ubN\
  RichEdit1.Modified := False;
  DispStatus;

  if (InfoList1.TagStr <> '') and (InfoList1.DataSize < ids) then
    LoadedFileAllData := False;
  Modified := mf;
end;

{ Xg[̃f[^ BSize oCg BCount ̃ubNɕ }
{ InfoList1 Ƀ[h葱 }

procedure TFrameForm.LoadStream(Stream: TStream);
var
  i, rs, ss: Integer;
  Ch: Char;
  P: PChar;
  D: TInfoBlock;
begin
  Stream.Position := 0;
  ss := Stream.Size;
  InfoList1.Clear; // ŏɃf[^SăNA[B
  if ss = 0 then
    Exit;

  RCount := BCount;
  RSize := BSize;
  BIndex := 0;

  if BCount = -1 then
  begin
    RCount := ss div BSize;
    if (ss mod BSize) <> 0 then
      Inc(RCount);
  end
  else if BCount = 0 then
  begin
    RCount := 1;
    RSize := ss;
  end
  else if BCount >= 1 then
  begin
    RCount := ss div BSize;
    if (ss mod BSize) <> 0 then
      Inc(RCount);
    if RCount > BCount then
      RCount := BCount;
  end;

  D.Data := Nil;
  D.Size := RSize;
  D.Comment := '0';

  P := Nil;
  ReallocMem(P, RSize + 4);
  try
    D.Data := P;
    for i := 0 to RCount - 1 do
    begin
      ZeroMemory(P, RSize + 4);
      rs := Stream.Read(P^, RSize);
      if (i < RCount - 1) and
         ((P[rs - 1] = #13) or (StrByteType(P, rs - 1) = mbLeadByte)) then
      begin
        if Stream.Read(Ch, 1) = 1 then
        begin
          P[rs] := Ch;
          Inc(rs);
        end;
      end;
      D.Size := rs;
      D.Comment := IntToStr(i);
      InfoList1.Add(D);
    end;
  finally
    ReallocMem(P, 0);
  end;
end;

{ t@C̃f[^ BSize oCg BCount ̃ubNɕ }
{ InfoList1 Ƀ[h葱 }

procedure TFrameForm.LoadFile(FileName: String);
var
  fs: Integer;
  Stream: TStream;
begin
  LoadedFileAllData := True; // Load all data of file.
  fs := SizeOfFile(FileName);
  if fs = -1 then // FileName ݂ȂfBNgłB
    Exit
  else if fs > 1024 * 1024 then // 1MB ȏ̏ꍇASĂǂݍ܂ȂB
  begin
    BSize := 256 * 1024; // 256KB
    BCount := 1024 * 1024 div BSize; // 4
  end;

  Stream := TFileStream.Create(FileName, fmOpenRead or fmShareDenyWrite);
  try
    LoadStream(Stream);
  finally
    Stream.Free;
  end;

  if InfoList1.DataSize < fs then
    LoadedFileAllData := False; // Loaded part data of file.
end;

{ InfoList1 ̑SubÑf[^1ɂ܂Ƃ߂ăXg[ }
{ ۑ葱 }

procedure TFrameForm.SaveStream(Stream: TStream);
var
  P: PChar;
begin
  P := InfoList1.Memory;
  Stream.Size := 0;
  Stream.Write(P^, InfoList1.DataSize);
end;

{ InfoList1 ̑SubÑf[^1ɂ܂Ƃ߂ăt@C }
{ ۑ葱 }

procedure TFrameForm.SaveFile(FileName: String);
var
  Stream: TStream;
begin
  Stream := TFileStream.Create(FileName, fmCreate);
  try
    SaveStream(Stream);
  finally
    Stream.Free;
  end;
end;

{ \̏ꍇ1ÕubNɈړ֐łB}
{  True Ԃ܂B}

function TFrameForm.GoLastBlock: Boolean;
begin
  Result := False;
  if BIndex <= 0 then
    Exit;

  ModifiedCheck;
  BinaryCheck;
  Dec(BIndex);

  case EditMode of
    0: RichEdit1.Text := InfoList1.TextItems[BIndex]; // Text Mode
    1: RichEdit1.Text := InfoList1.CrystalItems[BIndex]; // Crystal Mode
    2: RichEdit1.Text := InfoList1.DumpItems[BIndex]; // Dump Mode
    3: RichEdit1.Text := InfoList1.BinaryItems[BIndex]; // Binary Mode
  end;
  RichEdit1.Modified := False;

  RichEdit1.SelStart := RichEdit1.Perform(EM_LINEINDEX, LineCount - 1, 0);
  RichEdit1.Perform(EM_SCROLLCARET, 0, 0);

  Result := True;
end;

{ \̏ꍇɎ̃ubNɈړ֐łB}
{  True Ԃ܂B}

function TFrameForm.GoNextBlock: Boolean;
begin
  Result := False;
  if BIndex >= RCount - 1 then
    Exit;

  ModifiedCheck;
  BinaryCheck;
  Inc(BIndex);

  case EditMode of
    0: RichEdit1.Text := InfoList1.TextItems[BIndex]; // Text Mode
    1: RichEdit1.Text := InfoList1.CrystalItems[BIndex]; // Crystal Mode
    2: RichEdit1.Text := InfoList1.DumpItems[BIndex]; // Dump Mode
    3: RichEdit1.Text := InfoList1.BinaryItems[BIndex]; // Binary Mode
  end;
  RichEdit1.Modified := False;

  Result := True;
end;

{ BLines[] ɊeubN̍si[֐łB߂l͑SubN }
{ ̍vsłBIndex ͍Ōɕ\ubN̔ԍłB}

function TFrameForm.GetBLines(Index: Integer): Integer;
var
  i, n: Integer;
begin
  if Index < 0  then Index := 0
  else if Index > RCount - 1 then Index := RCount - 1;

  SetLength(BLines, RCount);
  Result := 0; n := 0;
  i := Index + 1;
  if i = RCount then i := 0;

  repeat
    case EditMode of
      0: RichEdit1.Text := InfoList1.TextItems[i]; // Text Mode
      1: RichEdit1.Text := InfoList1.CrystalItems[i]; // Crystal Mode
      2: RichEdit1.Text := InfoList1.DumpItems[i]; // Dump Mode
      3: RichEdit1.Text := InfoList1.BinaryItems[i]; // Binary Mode
    end;
    BLines[i] := LineCount; // ubN i ̍s
    Result := Result + BLines[i];
    Inc(i); Inc(n);
    if i = RCount then i := 0;
  until n = RCount;

  RichEdit1.Modified := False;
end;

{ RichEdit1 ̃r[GA̍sԂ֐ }

function TFrameForm.ViewLineCount: Integer;
begin
  Result := Round((RichEdit1.Height * 75) / (Abs(RichEdit1.Font.Height) * 100));
end;

{ RichEdit1 ̃r[GA̐擪̍sԍԂ֐ }

function TFrameForm.ViewTopLine: Integer;
begin
  Result := RichEdit1.Perform(EM_GETFIRSTVISIBLELINE, 0, 0) + 1;
end;

{ RichEdit1 ̃r[GA̐擪̍sԍw肷葱 }

procedure TFrameForm.SetViewTopLine(Value: Integer);
var
  SS: Integer;
begin
  SS := RichEdit1.Perform(EM_LINEINDEX, LineCount - 1, 0);
  RichEdit1.SelStart := SS; // ŏIs
  // RichEdit1.Perform(EM_SCROLLCARET, 0, 0);

  SS := RichEdit1.Perform(EM_LINEINDEX, Value - 1, 0);
  RichEdit1.SelStart := SS; // ws
  // RichEdit1.Perform(EM_SCROLLCARET, 0, 0);
end;

{ RichEdit1 ̃r[GA̐擪̃̕ZʒuԂ֐ }

function TFrameForm.ViewTopSel: Integer;
begin
  Result := RichEdit1.Perform(EM_LINEINDEX, ViewTopLine - 1, 0);
end;

{ RichEdit1 ̃r[GA̐擪̃Zʒuw肷葱 }

procedure TFrameForm.SetViewTopSel(Value: Integer);
var
  TL: Integer;
begin
  TL := RichEdit1.Perform(EM_LINEFROMCHAR, Value, 0) + 1;
  SetViewTopLine(TL);
end;

{ [JȃZʒuO[oȃZʒuɕϊĕԂ֐ }

function TFrameForm.Local2GlobalSel(Sel: Integer): Integer;
var
  i, LS, Len: Integer;
begin
  LS := Sel;
  Len := Length(RichEdit1.Text);
  if LS < 0 then LS := 0
  else if LS > Len - 1 then LS := Len - 1;

  Result := LS;
  for i := 0 to BIndex - 1 do
  begin
    case EditMode of
      0: Len := Length(InfoList1.TextItems[i]); // Text Mode
      1: Len := Length(InfoList1.CrystalItems[i]); // Crystal Mode
      2: Len := Length(InfoList1.DumpItems[i]); // Dump Mode
      3: Len := Length(InfoList1.BinaryItems[i]); // Binary Mode
    end;
    Result := Result + Len;
  end;
end;

{ O[oȃZʒu[JȃZʒuɕϊĕԂ֐ }

function TFrameForm.Global2LocalSel(GSel: Integer): Integer;
var
  i, GS, Len: Integer;
begin
  GS := GSel;
  Len := GlobalLen;
  if GS < 0 then GS := 0
  else if GS > Len - 1 then GS := Len - 1;

  Result := GS;
  i := 0;
  while (i < RCount) and (GS >= 0) do
  begin
    Result := GS;
    case EditMode of
      0: Len := Length(InfoList1.TextItems[i]); // Text Mode
      1: Len := Length(InfoList1.CrystalItems[i]); // Crystal Mode
      2: Len := Length(InfoList1.DumpItems[i]); // Dump Mode
      3: Len := Length(InfoList1.BinaryItems[i]); // Binary Mode
    end;
    GS := GS - Len;
    Inc(i);
  end;
end;

{ O[oȃZʒũubNԍԂ֐ }

function TFrameForm.GlobalSel2Block(GSel: Integer): Integer;
var
  i, GS, Len: Integer;
begin
  GS := GSel;
  Len := GlobalLen;
  if GS < 0 then GS := 0
  else if GS > Len - 1 then GS := Len - 1;

  i := 0;
  Result := i;
  while (i < RCount) and (GS >= 0) do
  begin
    Result := i;
    case EditMode of
      0: Len := Length(InfoList1.TextItems[i]); // Text Mode
      1: Len := Length(InfoList1.CrystalItems[i]); // Crystal Mode
      2: Len := Length(InfoList1.DumpItems[i]); // Dump Mode
      3: Len := Length(InfoList1.BinaryItems[i]); // Binary Mode
    end;
    GS := GS - Len;
    Inc(i);
  end;
end;

{ ݂ EditMode ɂf[^\̃O[oȃg[^̒Ԃ֐ }

function TFrameForm.GlobalLen: Integer;
var
  i: Integer;
begin
  Result := 0;
  for i := 0 to RCount - 1 do
  begin
    case EditMode of
      0: Result := Result + Length(InfoList1.TextItems[i]); // Text Mode
      1: Result := Result + Length(InfoList1.CrystalItems[i]); // Crystal Mode
      2: Result := Result + Length(InfoList1.DumpItems[i]); // Dump Mode
      3: Result := Result + Length(InfoList1.BinaryItems[i]); // Binary Mode
    end;
  end;
end;

{ ݂ EditMode ɂf[^\ 1 ubN̒Ԃ֐ }

function TFrameForm.BlockLen: Integer;
begin
  Result := 0;
  case EditMode of
    0: Result := Length(InfoList1.TextItems[0]); // Text Mode
    1: Result := Length(InfoList1.CrystalItems[0]); // Crystal Mode
    2: Result := Length(InfoList1.DumpItems[0]); // Dump Mode
    3: Result := Length(InfoList1.BinaryItems[0]); // Binary Mode
  end;
end;

{ ws̃CfgԂ֐łB}
{ 1 <= Line <= LineCount łȂ΂Ȃ܂B}

function TFrameForm.IndentStr(Line: Integer): String;
var
  i: Integer;
  S: String;
begin
  Result := '';
  if (Line < 1) or (Line > LineCount) then
    Exit;

  S := RichEdit1.Lines[Line - 1]; // ݍs̒l
  i := 1;
  while i <= Length(S) do
  begin
    if (S[i] <> ' ') and (S[i] <> #9) then
      Break;
    Inc(i);
  end;
  if i > 1 then
    Result := Copy(S, 1, i - 1);
end;

function TFrameForm.Hook(var Message: TMessage): Boolean;
begin
  case Message.Msg of
    CM_APPKEYDOWN:
      Result := True;
    CM_APPSYSCOMMAND:
      Result := True;
  else
    Result := False;
  end;
end;

function TFrameForm.ModifiedCheck: Boolean;
begin
  if (EditMode in [0, 2]) and (RichEdit1.Modified = True) then
  begin
    case EditMode of
      0: InfoList1.TextItems[BIndex] := RichEdit1.Text;
      2: InfoList1.DumpItems[BIndex] := RichEdit1.Text;
    end;
    Modified := True;
  end;

  BLines[BIndex] := LineCount;
  RichEdit1.Modified := False;
  Result := Modified;
end;

function TFrameForm.BinaryCheck: Boolean;
var
  i: Integer;
begin
  Result := False;
  for i := 0 to RCount - 1 do
  begin
    Result := InfoList1.IsBinary(i);
    if Result = True then
      Break;
  end;

  if (Result = True) and (InfoList1.BinaryOperation <> True) then
  begin
    InfoList1.BinaryOperation := True; // oCif[^̏ꍇA True ƂB
    Parameter1.VBools['BinaryOperation'] := InfoList1.BinaryOperation;
  end;

  if Result = True then
    StatusBar1.Panels[5].Text := '޲ް'
  else
    StatusBar1.Panels[5].Text := '÷ް';
end;

procedure TFrameForm.GetFindStr;
var
  i: Integer;
  Len: Integer;
  S: String;
begin
  if FindOption = False then
    Exit; // ݂ FindStr ̂܂܎gB

  if RichEdit1.SelLength <> 0 then
    S := Copy(RichEdit1.SelText, 1, 64) // ő 64 
  else
    S := Copy(RichEdit1.Text, RichEdit1.SelStart + 1, 64); // ő 64 
  Len := Length(S);

  i := 1;
  while i <= Len do
  begin
    if (Ord(S[i]) in Separator) then
      Break;
    Inc(i);
  end;
  Dec(i);

  if ByteType(S, i) = mbLeadByte then
    Dec(i);

  if i > 0 then
  begin
    FindStr := Copy(S, 1, i);
    if CM.Str <> FindStr then
      CM.Str := FindStr;
  end;
end;

procedure TFrameForm.AcceptFiles(var msg: TMessage);
var
  i, Count: Integer;
  Buf: array[0..255] of Char;
  Cur: String;
  Odd: String;
begin
  { hbvꂽt@C̐擾B}
  Count := DragQueryFile(msg.WParam, $FFFFFFFF, Buf, 255);
  Cur := '';
  Odd := '';
  for i := 0 to Count - 1 do
  begin
    { hbvꂽt@CtpXŎ擾B}
    DragQueryFile(msg.WParam, i, Buf, 255);
    if (InfoList1.TagStr = '') and (Length(RichEdit1.Text) = 0)
      and (Cur = '') then
      Cur := String(Buf)
    else
    begin
      if Odd <> '' then
        Odd := Odd + ' ';
      Odd := Odd + '"' + String(Buf) + '"';
    end;
  end;

  if Cur <> '' then
  begin
    if FileExists(Cur) then
    begin
      LoadFromFile(Cur);
      Caption := 'oCiN  Version 4.5 - ' + InfoList1.TagStr;
      FoundPos := 0;
      OldSel := 0;
      DispStatus;
    end
    else
      ShowMessage(Cur + ' ͊J܂B!!');
  end;

  if Odd <> '' then
  begin
    case EditMode of
      0: Odd := '/T ' + Odd; // Text Mode
      1: Odd := '/C ' + Odd; // Crystal Mode
      2: Odd := '/D ' + Odd; // Dump Mode
      3: Odd := '/B ' + Odd; // Binary Mode
    end;
    Odd := Odd + ' ';
    ShellExecute(Handle, PChar('open'), PChar(Application.ExeName),
     PChar(Odd), Nil, SW_SHOW);
  end;
end;

{ OnIdle CxǵCAvP[VAChԂ̂Ƃɔ܂B}

procedure TFrameForm.IdleHandler(Sender: TObject; var Done: Boolean);
begin
  if RichEdit1.Modified = False then
    ChangeCount := 0; // ύXꂽ

  if  Tag = 1 then // PreviewForm \ꂽB
  begin
    Tag := 0; //  IdleHandler ̓dN֎~B
    PreviewForm.Starting; // ŏ̃vr[\B
    Exit;
  end;
end;

{ OnActivate Cxg̓AvP[VANeBuɂȂƂɔ }
{ ܂B}

procedure TFrameForm.ActivateHandler(Sender: TObject);
begin
  if CM.Str <> '' then
    FindStr := CM.Str;
end;

procedure TFrameForm.LoadFromFile(FileName: String);
var
  i, j, ts: Integer;
  ext: String;
begin
  LoadFile(FileName);
  InfoList1.TagStr := FileName; // Ɍݕ\̃t@CB
  BinaryCheck; // oCif[^̃`FbN

  if FileName = Parameter1.VStrings['OpenFile'] then
  begin
    BIndex := Parameter1['LastBIndex']; // O\ĂubN
    GetBLines(BIndex); // BLines[] Ɋesi[Ă BIndex Ԃ̃ubN\
  end
  else
  begin
    BIndex := 0; // 擪̃ubN
    GetBLines(BIndex); // BLines[] Ɋesi[Ă擪̃ubN\
  end;

  ts := TabSize;
  if DefaultExt = True then
  begin
    ext := LowerCase(ExtractFileExt(FileName));
    if Length(ext) = 0 then ext := '.txt';

    if ext = '.pas' then
      ts := 2
    else if (ext = '.c') or (ext = '.h') or (ext = '.cpp') or (ext = '.hpp') then
      ts := 4
    else
      ts := 8;
  end;
  SetTabSize(ts);
  TabSize := ts;

  StatusBar1.Panels[2].Text := '';
  RichEdit1.Modified := False;
  Modified := False;

  if FileName = Parameter1.VStrings['OpenFile'] then
  begin
    j := Parameter1['LastSel'];
    j := RichEdit1.Perform(EM_LINEFROMCHAR, j, 0);
    i := Parameter1['LastViewTop'];
    if EditMode = 2 then // Dump Mode ̏ꍇ
      i := i * 491 div 100;
    SetViewTopLine(i);
    if (j >= i) and (j < i + ViewLineCount - 1) then
      RichEdit1.SelStart := Parameter1['LastSel'];
  end;
end;

procedure TFrameForm.SaveToFile(FileName: String);
begin
  ModifiedCheck;
  BinaryCheck;
  SaveFile(FileName);
end;

function TFrameForm.RichEditSetTabStops(const TabWidth: Integer): Boolean;
var
  tw: Integer;
  rs: Integer;
begin
  Result := False;
  tw := TabWidth * LOWORD(GetDialogBaseUnits) div 2;
  rs := RichEdit1.Perform(EM_SETTABSTOPS, 1, Longint(@tw));
  if rs <> 0 then
  begin
    RichEdit1.Invalidate;
    Result := True;
  end;
end;

{ ȉ̊֐ RichEditFillTabWidthsForFixedFont ́ADelphi [OXg }
{ ŌJĂԈ B̃R[hgpĒĂ܂B}
{ [Delphi-ML:41963] Re: RichEdit̃^uTCYݒFAboutDelphiTips  }

function TFrameForm.RichEditFillTabWidthsForFixedFont(const CharCount: Integer): Boolean;
const
  Directions: array[Boolean] of Integer = (LOGPIXELSY, LOGPIXELSX);
var
  ptsCharSize: Currency;
  DC: HDC;
  hOldFont: HFONT;
  fAveCharWidth: Currency;
  //  TM: TextMetric;
  Para: TParaFormat;
  TmpSelStart: Integer;
  TmpSelLength: Integer;
  i: Integer;
  rs: Integer;

  // _tŎ擾B
  //  (Windows2000 ȍ~ł͂ȂȊ֐͎g킸
  //  API gpꂽB)
  function GetCharacterWidthI_(DC: HDC; wCharCode: Word): Currency;
  var
    P: PWord;
    j: Integer;
    szWidth: TSize;
    cMaxWidths: array[0..511] of Char;
    wTmpCharCode: Word;
  begin
    ASSERT(
      1 = ((High(cMaxWidths) - Low(cMaxWidths)) and 1),
      'cMaxWidths ̃TCYɂĂB');

    // cMaxWidths 𕶎ŖߐsB
    if wCharCode <= $FF then
      FillChar(cMaxWidths, SizeOf(cMaxWidths), wCharCode)
    else
    begin
      cMaxWidths[Low(cMaxWidths) + 0] := Char(HiByte(wCharCode));
      cMaxWidths[Low(cMaxWidths) + 1] := Char(LoByte(wCharCode));
      P := PWord(@cMaxWidths[Low(cMaxWidths)]);
      wTmpCharCode := P^;
      Inc(P);
      for j := 2 to SizeOf(cMaxWidths) div SizeOf(Word) do
      begin
        P^ := wTmpCharCode;
        Inc(P);
      end;
    end;

    // Ŝł̕\擾
    j := SizeOf(cMaxWidths);
    while (j > 0) and (not GetTextExtentPoint(DC,
          @cMaxWidths[Low(cMaxWidths)], j, szWidth)) do
      Dec(j, 2);

    if (j = 0) then
      Result := 0
    else if wCharCode <= $FF then // P̕擾
      Result := szWidth.cx / j
    else
      Result := szWidth.cx / (j shr 1);
  end;

  // ľܓ(p)
  function RoundOffPositive(X: Extended): Cardinal;
  begin
    ASSERT(X >= 0);
    if x >= 0 then
      Result := Trunc(x + 0.6)
    else
      Result := 0;
  end;

begin
  Result := False;
  DC := GetDC(Handle);
  hOldFont := SelectObject(DC, Font.Handle);
  fAveCharWidth := GetCharacterWidthI_(DC, Ord('M'));
  //  GetTextMetrics(DC, TM);
  //  fAveCharWidth := TM.tmAveCharWidth;
  ptsCharSize := 72 * (fAveCharWidth / GetDeviceCaps(DC, Directions[True]));
  SelectObject(DC, hOldFont);
  ReleaseDC(Handle, DC);

  { TabTCY̐ݒ }
  // ̂߁ATab vpeBł͂ȂARichEditControl 
  // bZ[W(EM_SETPARAFORMAT)gp܂B
  // p[^ TParaFormat ^ŁA^uݒɎĝ́A
  // TParaFormat.rgxTabs złB
  // ̔zɂ́A^uʒu twip P(20 twip = 1 point)
  // Ŏw肵܂B
  Para.cbSize := SizeOf(TParaFormat);
  Para.dwMask := PFM_TABSTOPS;
  Para.cTabCount := High(Para.rgxTabs) - Low(Para.rgxTabs) + 1;
  ASSERT(Low(Para.rgxTabs) = 0);

  // ^uʒu̒l Para.rgxTabs zɕ~l߂BPʂ twip
  for i := Low(Para.rgxTabs) to High(Para.rgxTabs) do
    Para.rgxTabs[i] :=
      RoundOffPositive(20 * ((i + 1) * (ptsCharSize * CharCount)));

  // ^uʒu̐ݒ
  RichEdit1.Lines.BeginUpdate;
  // Iʒüꎞۑ
  TmpSelStart := RichEdit1.SelStart;
  TmpSelLength := RichEdit1.SelLength;
  // SpOtIA^uʒuݒ
  RichEdit1.SelectAll;
  rs := Perform(EM_SETPARAFORMAT, 0, Longint(@Para));
  // Iʒu̕A
  RichEdit1.SelStart := TmpSelStart;
  RichEdit1.SelLength := TmpSelLength;
  RichEdit1.Lines.EndUpdate;
  if rs <> 0 then
    Result := True;
end;

procedure TFrameForm.SetTabSize(Value: Integer);

  function TabSet(const TabWidth: Integer): Boolean;
  begin
    Result := RichEditSetTabStops(TabWidth);
    if Result = False then
      Result := RichEditFillTabWidthsForFixedFont(TabWidth);
  end;

begin
  if (Value in [0..32]) and (EditMode = 0) then
    TabSet(Value); // ^uTCY̕ύX
end;

{ OnShow ŃobNAbvt@C肷B}

procedure TFrameForm.MakeBackupFileName;
var
  i: Integer;
  S, N, E: String;
begin
  BackupFileName := '';

  S := ExtractFilePath(Application.ExeName) + 'Backup\$~';
  if InfoList1.TagStr = '' then N := '.txt'
  else N := ExtractFileName(InfoList1.TagStr);

  if Copy(N, 1, 2) = '$~' then
    Exit; // obNAbvt@C̃obNAbvt@C͍ȂB

  E := ExtractFileExt(N);
  N := ChangeFileExt(N, '');

  i := 1;
  while i <= 100 do
  begin
    BackupFileName := S + N + IntToStr(i) + E;
    if not FileExists(BackupFileName) then Break;
    Inc(i);
  end;
  if i > 100 then BackupFileName := '';
end;

{ obNAbvt@C쐬֐łB쐬ꍇ True  }
{ 쐬Ȃꍇ False Ԃ܂B}

function TFrameForm.MakeBackupFile: Boolean;
begin
  Result := False;

  if (Parameter1.VBools['MBackupFile'] = False) or (BackupFileName = '') or
     (InfoList1.DataSize = 0) or (Modified = False) then
    Exit;

  SaveToFile(BackupFileName);

  Result := True;
end;

{ obNAbvt@C폜葱łB}

procedure TFrameForm.DeleteBackupFiles(Undo: Boolean);
var
  i: Integer;
  Dir: String;
  Files: TStringList;
  Recs: TSearchRecs;
begin
  Dir := ExtractFilePath(BackupFileName);
  Files := TStringList.Create;
  Files.Duplicates := dupAccept;
  try
    Recs := TSearchRecs.Create;
    try
      Recs.Path := Dir + '*.*';
      for i := 0 to Recs.Count - 1 do
        Files.Add(Dir + Recs[i].Name);
    finally
      Recs.Clear;
      Recs.Free;
    end;
    DeleteFiles(Files, Undo);
  finally
    Files.Clear;
    Files.Free;
  end;
end;

function TFrameForm.LineLength: Integer;
begin
  Result := SendMessage(RichEdit1.Handle, EM_LINELENGTH, RichEdit1.SelStart, 0);
end;

function TFrameForm.LineCount: Integer;
begin
  Result := SendMessage(RichEdit1.Handle, EM_GETLINECOUNT, 0, 0);
end;

function TFrameForm.CX: Integer;
begin
  Result := RichEdit1.SelStart - RichEdit1.Perform(EM_LINEINDEX, CY - 1, 0) + 1;
end;

procedure TFrameForm.SetCX(Value: Integer);
var
  x: Integer;
  len: Integer;
begin
  x := CX; // ݂̗ʒu
  if (Value <> x) and (Value >= 1) then
  begin
    len := LineLength + 1; // ݍs̒ + 1
    if Value < len then
      len := Value;
    len := len - x; // J[\̈ړ
    if len <> 0 then
    begin
      RichEdit1.SelStart := RichEdit1.SelStart + len; // Vʒu
      RichEdit1.Perform(EM_SCROLLCARET, 0, 0);
    end;
  end;
end;

function TFrameForm.CY: Integer;
begin
  Result := RichEdit1.Perform(EM_LINEFROMCHAR, -1, 0) + 1;
end;

procedure TFrameForm.SetCY(Value: Integer);
var
  x: Integer;
begin
  if (Value <> CY) and (Value >= 1) and (Value <= LineCount) then
  begin
    x := CX; // ύXO̗ʒu
    RichEdit1.SelStart := SendMessage(RichEdit1.Handle, EM_LINEINDEX, Value - 1, 0);
    RichEdit1.Perform(EM_SCROLLCARET, 0, 0);
    SetCX(x); // ʒuƂɖ߂B
  end;
end;

{ ReplaceOne ́Ã݂ZʒuҏWf[^ɂ镔 FindText }
{ ̐擪wĂ΁A̕̕ҏWf[^ ReplaceText Œu }
{ ֐łBuꍇ́ATrue łȂꍇ́AFalse Ԃ܂B}
{ MatchCase  False ̏ꍇ́AҏWf[^ FindText ŔpAt@xbg }
{ ̑啶Əʂ܂B}

function TFrameForm.ReplaceOne(const FindText: String; const ReplaceText: String; MatchCase: Boolean): Boolean;
var
  i: Integer;
begin
  Result := False;
  i := RichEdit1.SelStart;
  RichEdit1.Perform(EM_SCROLLCARET, 0, 0);

  if PosI(FindText, RichEdit1.Text, i, MatchCase) - 1 <> i then
    Exit;

  RichEdit1.SelLength := 0; // I͈͂NA[Ă
  RichEdit1.SelLength := Length(FindText);
  RichEdit1.SelText := ReplaceText;

  if EditMode = 0 then // eLXg[h̏ꍇ̂݃f[^XVB
  begin
    InfoList1.TextItems[BIndex] := RichEdit1.Text;
    Modified := True;
  end;

  BLines[BIndex] := LineCount; // JgubN̍sXVB
  RichEdit1.Modified := False;
  Result := True;
end;

{ ReplaceSel ́AҏWf[^̑I𕔕ɂ镔 FindText S }
{ ReplaceText ŒuAuԂ֐łBMatchCase  False  }
{ ꍇ́AҏWf[^ FindText ŔpAt@xbg̑啶Ə }
{ ʂ܂BText Mode őI𕔕݂ꍇ̂ݒusȂ܂B}

function TFrameForm.ReplaceSel(const FindText: String; const ReplaceText: String; MatchCase: Boolean): Integer;
var
  i, j: Integer;
  S: String;
begin
  Result := 0;
  if (EditMode <> 0) or (RichEdit1.SelLength = 0) then
    Exit; // Text Mode ȊȌꍇI𕔕݂Ȃꍇ͉ȂB

  i := RichEdit1.SelStart; // ݂̃Zʒu
  ModifiedCheck; // f[^XVB
  BinaryCheck; // oCi`FbN

  S := RichEdit1.SelText;
  Result := ReplaceString(S, FindText, ReplaceText, MatchCase);
  j := Length(S);
  if Result > 0 then // f[^XVB
  begin
    RichEdit1.SelText := S;
    InfoList1.TextItems[BIndex] := RichEdit1.Text;
    Modified := True;
    RichEdit1.Modified := False;
  end;

  RichEdit1.SelStart := i; // ZʒuƂɖ߂B
  RichEdit1.SelLength := j;
  RichEdit1.Perform(EM_SCROLLCARET, 0, 0);
end;

{ ReplaceAll ́AҏWf[^ɂ镔 FindText S ReplaceText  }
{ uAuԂ֐łBMatchCase  False ̏ꍇ́AҏWf[^ }
{  FindText ŔpAt@xbg̑啶Əʂ܂B}

function TFrameForm.ReplaceAll(const FindText: String; const ReplaceText: String; MatchCase: Boolean): Integer;
var
  i, j, rs: Integer;
  S: String;
begin
  Result := 0;
  j := RichEdit1.SelStart; // ݂̃Zʒu

  ModifiedCheck; // f[^XVB
  BinaryCheck; // oCi`FbN

  for i := 0 to RCount - 1 do
  begin
    { ݂ EditMode Ɋ֌WȂeLXg`\ł̒usȂB}
    S := InfoList1.TextItems[i];
    rs := ReplaceString(S, FindText, ReplaceText, MatchCase);
    if rs > 0 then
    begin
      InfoList1.TextItems[i] := S; // f[^XVB
      Result := Result + rs;
      Modified := True;
    end;
  end;

  if Result > 0 then
  begin
    GetBLines(BIndex); // BLines[] Ɋesi[Ă BIndex Ԃ̃ubN\
    RichEdit1.Modified := False;
  end;

  if j > Length(RichEdit1.Text) then
    j := Length(RichEdit1.Text);
  RichEdit1.SelStart := j; // ZʒuƂɖ߂B
  RichEdit1.Perform(EM_SCROLLCARET, 0, 0);
end;

procedure TFrameForm.Open1Click(Sender: TObject);
var
  Param: String;
begin
  if OpenDialog1.Execute then
  begin
    if (InfoList1.TagStr = '') and (ModifiedCheck = False) then
    begin
      LoadFromFile(OpenDialog1.FileName);
      MakeBackupFileName; // BackupFileName 蒼B
      Caption := 'oCiN  Version 4.5 - ' + InfoList1.TagStr;
      FoundPos := 0;
      OldSel := 0;
      DispStatus;
    end
    else
    begin
      case EditMode of
        0: Param := '/T '; // Text Mode
        1: Param := '/C '; // Crystal Mode
        2: Param := '/D '; // Dump Mode
        3: Param := '/B '; // Binary Mode
      end;
      Param := Param + ' "' + OpenDialog1.FileName + '"';
      ShellExecute(Handle, PChar('open'), PChar(Application.ExeName),
                   PChar(Param), Nil, SW_SHOW);
    end;
  end;
end;

procedure TFrameForm.FormShow(Sender: TObject);
var
  i, j, ts: Integer;
  Ch: Char;
  Odd, ext: String;
  Err: Boolean;
  Mf: Boolean;
  FileName, Dir: String;
begin
  { ҏWRg[֌W̏ }
  RichEdit1.Clear;
  LoadedFileAllData := True; // t@C̑Sf[^[hĂ邩ǂtO
  BCount := 0; // f[^̕
  RCount := 1; // ŏIIȎۂ̕
  BSize := 1024 * 16; // f[^̕TCY
  RSize := 0; // ŏIIȎۂ̕TCY
  BIndex := InfoList1.AddText('', ''); // ̃f[^Ēu
  SetLength(BLines, 1); // eubN̍si[ׂ̔z
  BLines[0] := 1; // ̃f[^łĂ1sڂ݂͑B
  InfoList1.TagStr := '';
  MatchCase := True;
  Indent := True;
  FindStr := '';
  FindOption := True;
  FoundPos := 0;
  OldDown := True;
  OldSel := 0;
  Jump := '1';
  TabSize := 4;
  DefaultExt := True;
  EditMode := 0; // Text Mode
  InsertMode := True; // }[h
  StatusBar1.Panels[2].Text := '';
  Modified := False; // ҏW̃f[^ύXĂ鎖tO
  RichEdit1.Modified := False;
  ChangeCount := 0; // ύXꂽ
  { AhEׂ̍\ UD }
  UD.Modified := False;
  UD.SelStart := 0;
  UD.ReSelStart := 0;
  UD.SelText := '';
  UD.CanUndo := False;

  { AvP[V̊ep[^֌W̏ }
  Parameter1.Init; // Parameter1 Ăep[^t@C烍[hB
  if Parameter1.Count > 0 then // p[^̃[hɐꍇ
  begin
    Mf := RichEdit1.Modified;
    WindowState := TWindowState(Parameter1['WindowState']);
    if WindowState <> wsMaximized then
    begin
      ClientWidth := Parameter1['ClientWidth'];
      ClientHeight := Parameter1['ClientHeight'];
    end;
    RichEdit1.Font.Name := Parameter1.VStrings['FontName'];
    RichEdit1.Font.Size := Parameter1['FontSize'];
    RichEdit1.Font.Style := Parameter1.VFontStyles['FontStyle'];
    RichEdit1.Font.Color := Parameter1['FontColor'];
    FontDialog1.Font := RichEdit1.Font;
    RichEdit1.Modified := Mf;
    RichEdit1.WordWrap := Parameter1.VBools['WordWrap'];
    InfoList1.BinaryOperation := Parameter1.VBools['BinaryOperation'];
    BCount := Parameter1['BCount'];
    BSize := Parameter1['BSize'] * 1024; // 1K oCgPʂ̒lĂ̂ŁB
    TabSize := Parameter1['TabSize'];
    DefaultExt := Parameter1.VBools['DefaultExt'];
    MatchCase := Parameter1.VBools['MatchCase'];
    Indent := Parameter1.VBools['Indent'];
    FindDialogbox1.EOption := Parameter1.VBools['EOption'];
    FindDialogbox1.FOption := Parameter1.VBools['FOption'];
    FindStr := Parameter1.VStrings['FindStr'];
    FindOption := Parameter1.VBools['FindOption'];
    OpenDialog1.FileName := Parameter1.VStrings['OpenFile'];
    OpenDialog1.InitialDir := ExtractFileDir(OpenDialog1.FileName);
    SaveDialog1.FileName := Parameter1.VStrings['SaveFile'];
    SaveDialog1.InitialDir := ExtractFileDir(SaveDialog1.FileName);
  end
  else // p[^[hoȂꍇ
  begin
    Parameter1.Add('oCiNݒt@C --- ̃t@ĆAҏWȂŉB');
    Parameter1['WindowState'] := Integer(WindowState);
    ClientWidth := 693; Parameter1['ClientWidth'] := ClientWidth;
    ClientHeight := 446; Parameter1['ClientHeight'] := ClientHeight;
    Parameter1.VStrings['FontName'] := RichEdit1.Font.Name;
    Parameter1['FontSize'] := RichEdit1.Font.Size;
    Parameter1.VFontStyles['FontStyle'] := RichEdit1.Font.Style;
    Parameter1['FontColor'] := RichEdit1.Font.Color;
    FontDialog1.Font := RichEdit1.Font;
    Parameter1.VBools['WordWrap'] := RichEdit1.WordWrap;
    Parameter1.VBools['BinaryOperation'] := InfoList1.BinaryOperation;
    Parameter1['BCount'] := BCount;
    Parameter1['BSize'] := BSize div 1024; // 1K oCgPʂ̒lB
    Parameter1['TabSize'] := TabSize;
    Parameter1.VBools['DefaultExt'] := DefaultExt;
    Parameter1.VBools['MBackupFile'] := True;
    Parameter1.VBools['MatchCase'] := MatchCase;
    Parameter1.VBools['Indent'] := Indent;
    Parameter1.VBools['EOption'] :=  FindDialogbox1.EOption;
    Parameter1.VBools['FOption'] :=  FindDialogbox1.FOption;
    Parameter1.VStrings['FindStr'] := FindStr;
    Parameter1.VBools['FindOption'] := FindOption;
    Parameter1.VStrings['OpenFile'] := OpenDialog1.FileName;
    Parameter1.VStrings['SaveFile'] := SaveDialog1.FileName;
    Parameter1['LastBIndex'] := 0;
    Parameter1['LastViewTop'] := 1;
    Parameter1['LastSel'] := 0;
    Parameter1['LineNumber'] := 0;
    Parameter1['Partition'] := 1;
    Parameter1['PartitionGap'] := 32;
    Parameter1['PILeftMargin'] := 76;
    Parameter1['PIRightMargin'] := 76;
    Parameter1['PIBottomMargin'] := 92;
    Parameter1['PITopMargin'] := 76;
    Parameter1['PrintOption'] := poFileName or poTimeStamp or poPageNumber;
  end;

  ts := TabSize;
  if DefaultExt = True then
  begin
    ext := LowerCase(ExtractFileExt(InfoList1.TagStr));
    if Length(ext) = 0 then ext := '.txt';

    if ext = '.pas' then
      ts := 2
    else if (ext = '.c') or (ext = '.h') or (ext = '.cpp') or (ext = '.hpp') then
      ts := 4
    else
      ts := 8;
  end;
  SetTabSize(ts);
  TabSize := ts;

  BinaryCheck;
  FileName := ExtractFilePath(Application.ExeName) + 'Find.txt';
  if FileExists(FileName) then
  begin
    FindDialogBox1.FindItems.LoadFromFile(FileName);
    ReplaceDialogBox1.FindItems.LoadFromFile(FileName);
    ReplaceDialogBox1.ReplaceItems.LoadFromFile(FileName);
  end;

  FindDialogBox1.PPoint := Point(Screen.Width div 2, Screen.Height div 2);
  ReplaceDialogBox1.PPoint := Point(Screen.Width div 2, Screen.Height div 2);

  { ÑIuVƃt@C̎擾 }
  Odd := '';
  Err := False;
  for i := 1 to ParamCount do
  begin
    if ParamStr(i)[1] = '/' then
    begin
      Ch := UpCase(ParamStr(i)[2]);
      if Ch = 'T' then EditMode := 0       // Text Mode
      else if Ch = 'C' then EditMode := 1  // Crystal Mode
      else if Ch = 'D' then EditMode := 2  // Dump Mode
      else if Ch = 'B' then EditMode := 3  // Binary Mode
      else if Ch = 'N' then // BCount(f[^̕)
      begin
        try
          j := StrToInt(Copy(ParamStr(i), 3, Length(ParamStr(i)) - 2));
        except
          j := 0;
        end;
        if (j < -1) or (j > 1024) then j := 0;
        BCount := j;
      end
      else if Ch = 'S' then // BSize(f[^̕TCY)
      begin
        try
          j := StrToInt(Copy(ParamStr(i), 3, Length(ParamStr(i)) - 2));
        except
          j := 16;
        end;
        if (j < 1) or (j > 256) then j := 16;
        BSize := j * 1024; // j  1K oCgPʂ̒l
      end;
    end
    else if InfoList1.TagStr = '' then
      InfoList1.TagStr := ParamStr(i)
    else
    begin
      if Odd <> '' then
        Odd := Odd + ' ';
      Odd := Odd + '"' + ParamStr(i) + '"';
    end;
  end;

  case EditMode of
    0: StatusBar1.Panels[4].Text := '÷Ӱ';
    1: StatusBar1.Panels[4].Text := 'ؽӰ';
    2: StatusBar1.Panels[4].Text := 'Ӱ';
    3: StatusBar1.Panels[4].Text := '޲Ӱ';
  end;

  if InfoList1.TagStr <> '' then
  begin
    if FileExists(InfoList1.TagStr) then
    begin
      LoadFromFile(InfoList1.TagStr);
      Caption := 'oCiN  Version 4.5 - ' + InfoList1.TagStr;
      FoundPos := 0;
      OldSel := 0;
    end
    else
    begin
      ShowMessage(InfoList1.TagStr + ' ͊J܂B!!');
      Err := True;
    end;
  end;

  DispStatus;

  if Odd <> '' then
  begin
    case EditMode of
      0: Odd := '/T ' + Odd; // Text Mode
      1: Odd := '/C ' + Odd; // Crystal Mode
      2: Odd := '/D ' + Odd; // Dump Mode
      3: Odd := '/B ' + Odd; // Binary Mode
    end;
    Odd := Odd + ' ';
    ShellExecute(Handle, PChar('open'), PChar(Application.ExeName),
                 PChar(Odd), Nil, SW_SHOW);
  end;

  if Err then
    Close;

  MakeBackupFileName;
  Dir := ExtractFilePath(Application.ExeName) + 'Backup';
  if not DirectoryExists(Dir) then
    CreateDir(Dir);
end;

procedure TFrameForm.F1Click(Sender: TObject);
var
  Mf: Boolean;
begin
  FontDialog1.Font := RichEdit1.Font;
  if FontDialog1.Execute then
  begin
    Mf := RichEdit1.Modified;
    RichEdit1.Font := FontDialog1.Font;
    RichEdit1.Modified := Mf;
  end;
end;

procedure TFrameForm.DispStatus;
var
  i, j, k: Integer;
  X, Y: Integer;
  Len: Integer;
  S: String;
  CC: String;
begin
  CC := '';
  i := RichEdit1.SelStart;
  CC := Copy(RichEdit1.Text, i + 1, 2);

  { BLines[BIndex] ÕubN̍s̍v߂B}
  j := 0; k := 0;
  while j < BIndex do
  begin
    k := k + BLines[j];
    Inc(j);
  end;

  Y := RichEdit1.Perform(EM_LINEFROMCHAR, -1, 0) + 1;
  X := i - RichEdit1.Perform(EM_LINEINDEX, Y - 1, 0) + 1;
  S := IntToStr(k + Y) + ',' + IntToStr(X);
  StatusBar1.Panels[0].Text := S; // J[\ʒu

  S := '  : ';
  if CC <> '' then
  begin
    if ByteTypeX(CC, 1) = mbLeadByte then
    begin
      S[1] := CC[1]; S[2] := CC[2];
      S := S + IntToHex(Ord(CC[1]), 2); S := S + IntToHex(Ord(CC[2]), 2);
    end
    else
    begin
      if Ord(CC[1]) > $20 then
        S[2] := CC[1];
      S := S + IntToHex(Ord(CC[1]), 2);
    end;
  end;
  StatusBar1.Panels[1].Text := S; // J[\ʒu̕ƕR[h

  if Modified or ((EditMode in [0, 2]) and RichEdit1.Modified) then
    StatusBar1.Panels[2].Text := 'ύX'
  else
    StatusBar1.Panels[2].Text := '';

  Len := InfoList1.DataSize;
  if (Len > 0) and (Len < 1024) then
    Len := 1
  else
    Len := Len div 1024;
  StatusBar1.Panels[6].Text := IntToStr(Len) + ' KB'; // f[^̃TCY

  if BCount = 0 then
    StatusBar1.Panels[7].Text := 'A'
  else
    StatusBar1.Panels[7].Text := IntToStr(BIndex + 1) +
               '/' + IntToStr(RCount);

  if i = OldSel then
  begin
    if FoundPos = -1 then
      StatusBar1.Panels[8].Text := '񂪌܂B'
    else
      StatusBar1.Panels[8].Text := '';
  end
  else
  begin
    FoundPos := 0;
    StatusBar1.Panels[8].Text := '';
    OldSel := i;
  end;
end;

procedure TFrameForm.X1Click(Sender: TObject);
var
  mr: Word;
  DN: String;
begin
  if InfoList1.TagStr = '' then
    DN := ''
  else
    DN := InfoList1.TagStr;
  if ModifiedCheck and LoadedFileAllData then
  begin
    mr := MessageDlg('̧ ' + DN + ' ̓eύXĂ܂B' + #13#10
     + #13#10 + 'ύXۑ܂ ?', mtWarning, [mbYes, mbNo, mbCancel], 0);
    if mr = mrYes then
    begin
      if (Parameter1.VBools['MBackupFile'] = True) and (InfoList1.TagStr <> '') then
        CopyFile(PChar(InfoList1.TagStr), PChar(BackupFileName), False); // ̃t@CobNAbvtH_ɕۑB
      Save1Click(Sender);
    end
    else if mr = mrNo then
      MakeBackupFile
    else if mr = mrCancel then
    begin
      BinaryCheck;
      Exit;
    end;
  end;
  Tag := -1; // j[̏INbNƂTC
  Close;
end;

procedure TFrameForm.Save1Click(Sender: TObject);
begin
  if InfoList1.TagStr = '' then
    SaveAs1Click(Sender)
  else
  begin
    SaveToFile(InfoList1.TagStr);
    StatusBar1.Panels[2].Text := '';
    Modified := False;
    RichEdit1.Modified := False;
  end;
end;

procedure TFrameForm.N1Click(Sender: TObject);
var
  SW: String;
begin
  SW := ' ';
  ShellExecute(Handle, PChar('open'), PChar(Application.ExeName),
               PChar(SW), Nil, SW_SHOW);
end;

procedure TFrameForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
var
  mr: Word;
  i: Integer;
  DN: String;
  FileName: String;
begin
 { ҏWt@C̕ۑ }
  if InfoList1.TagStr = '' then
    DN := ''
  else
    DN := InfoList1.TagStr;
  if ModifiedCheck and LoadedFileAllData and (Tag <> -1) then
  begin
    mr := MessageDlg('̧ ' + DN + ' ̓eύXĂ܂B' + #13#10
     + #13#10 + 'ύXۑ܂ ?', mtWarning, [mbYes, mbNo, mbCancel], 0);
    if mr = mrYes then
    begin
      if (Parameter1.VBools['MBackupFile'] = True) and (InfoList1.TagStr <> '') then
        CopyFile(PChar(InfoList1.TagStr), PChar(BackupFileName), False); // ̃t@CobNAbvtH_ɕۑB
      Save1Click(Sender);
    end
    else if mr = mrNo then
    begin
      MakeBackupFile;
      CanClose := True;
    end
    else if mr = mrCancel then
    begin
      BinaryCheck;
      CanClose := False;
    end;
  end;

 { AvP[V̊ep[^̕ۑ }
  Parameter1['WindowState'] := Integer(WindowState);
    if WindowState <> wsMaximized then
  begin
    Parameter1['ClientWidth'] := ClientWidth;
    Parameter1['ClientHeight'] := ClientHeight;
  end;
  Parameter1.VStrings['FontName'] := RichEdit1.Font.Name;
  Parameter1['FontSize'] := RichEdit1.Font.Size;
  Parameter1.VFontStyles['FontStyle'] := RichEdit1.Font.Style;
  Parameter1['FontColor'] := RichEdit1.Font.Color;
  Parameter1['TabSize'] := TabSize;
  Parameter1.VBools['DefaultExt'] := DefaultExt;
  Parameter1.VBools['WordWrap'] := RichEdit1.WordWrap;
  Parameter1['BCount'] := BCount;
  Parameter1['BSize'] := BSize div 1024; // 1K oCgPʂ̒lۑB
  Parameter1.VBools['MatchCase'] := MatchCase;
  Parameter1.VBools['Indent'] := Indent;
  Parameter1.VBools['EOption'] :=  FindDialogbox1.EOption;
  Parameter1.VBools['FOption'] :=  FindDialogbox1.FOption;
  Parameter1.VStrings['FindStr'] := FindStr;
  Parameter1.VBools['FindOption'] := FindOption;
  Parameter1.VStrings['OpenFile'] := OpenDialog1.FileName;
  Parameter1.VStrings['SaveFile'] := SaveDialog1.FileName;

  if InfoList1.TagStr <> '' then
  begin
    Parameter1['LastBIndex'] := BIndex;
    i := ViewTopLine;
    if EditMode = 2 then // Dump Mode ̏ꍇ
    begin
      i := i * 100 div 491;
      if i = 0 then i := 1;
    end;
    Parameter1['LastViewTop'] := i;
    Parameter1['LastSel'] := RichEdit1.SelStart;
  end;
  Parameter1.SaveToFile;

  FileName := ExtractFilePath(Application.ExeName) + 'Find.txt';
  FindDialogBox1.FindItems.SaveToFile(FileName);
end;

procedure TFrameForm.SaveAs1Click(Sender: TObject);
var
  DN: String;
  n: Integer;
  mr: Word;
begin
  DN := InfoList1.TagStr;
  if DN = '' then
    DN := ExtractFilePath(Parameter1.VStrings['SaveFile'])+ '.txt'; 
  SaveDialog1.InitialDir := ExtractFileDir(DN);
  SaveDialog1.FileName := DN;
  if SaveDialog1.Execute then
  begin
    Parameter1.VStrings['SaveFile'] := SaveDialog1.FileName;
    DN := SaveDialog1.FileName;
    n := Length(DN);
    if DN[n] = '.' then // t@C̍Ō '.' ̏ꍇ́A'.' 菜B
      DN := Copy(DN, 1, n - 1);
    if FileExists(DN) then
    begin
      mr := MessageDlg(DN + ' ͊ɑ݂܂B' + #13#10
       + #13#10 + '㏑܂ ?', mtWarning, [mbYes, mbNo], 0);
      if mr = mrYes then
      begin
        SaveToFile(DN);
        Modified := False;
        StatusBar1.Panels[2].Text := '';
        InfoList1.TagStr := DN;
        Caption := 'oCiN  Version 4.5 - ' + InfoList1.TagStr;
      end;
    end
    else
    begin
      SaveToFile(DN);
      Modified := False;
      StatusBar1.Panels[2].Text := '';
      InfoList1.TagStr := DN;
      Caption := 'oCiN  Version 4.5 - ' + InfoList1.TagStr;
    end;
  end;
end;

function TFrameForm.GetPrintMessage: Word;
var
  S: String;
begin
  S := '!! ݕ[hœ쒆̂' + #13#10 +
       'f[^̈ꕔ݂̂ҏWĂ܂B' + #13#10 + #13#10 +
       '̂܂܈ꕔ݂̂܂B(OK)' + #13#10 +
       'ƂŜ܂B(ׂ)';

  Result := mrOK;

  if (RCount > 1) and (RichEdit1.SelLength = 0) then
    Result := MessageDlg(S, mtWarning, [mbOk, mbAll, mbCancel], 0);
end;

procedure TFrameForm.Print1Click(Sender: TObject);
var
  S: String;
  P: PChar;
  bc, bi, ss, vs: Integer;
begin
  if RichEdit1.Text <> '' then
  begin
    if PrintDialog1.Execute then
    begin
      PrintMessage := GetPrintMessage;
      if PrintMessage = MrCancel then
        Exit
      else if PrintMessage = MrOk then
        P := PChar(RichEdit1.Text)
      else if PrintMessage = MrAll then
      begin
        bc := BCount;
        bi := BIndex;
        ss := RichEdit1.SelStart;
        vs := ViewTopSel; // r[GA̐擪̃̕Zʒu
        BCount := 0; // f[^1̃ubNɂ܂Ƃ߂B
        BIndex := 0; // 擪̃ubN
        RemakeData(BIndex); // f[^č\zB
        case EditMode of
          0: S := InfoList1.TextItems[0];
          1: S := InfoList1.CrystalItems[0];
          2: S := InfoList1.DumpItems[0];
          3: S := InfoList1.BinaryItems[0];
        end;
        P := PChar(S);
        BCount := bc; // Ƃɖ߂B
        BIndex := bi; // Ƃɖ߂B
        RemakeData(BIndex); // f[^č\zB
        SetViewTopSel(vs);
        RichEdit1.SelStart := ss;
      end
      else
        P := PChar(RichEdit1.Text);

      if PrintDialog1.PrintRange = prAllPages then // [ׂ]׼޵݂I
        PrintText(P,
                  InfoList1.TagStr,
                  RichEdit1.Font,
                  TabSize,
                  Parameter1['LineNumber'],
                  Parameter1['PILeftMargin'],
                  Parameter1['PIRightMargin'],
                  Parameter1['PITopMargin'],
                  Parameter1['PIBottomMargin'],
                  Parameter1['Partition'],
                  Parameter1['PartitionGap'],
                  Parameter1['PrintOption'],
                  RichEdit1.Font,
                  PrintDialog1.Copies)
      else if  PrintDialog1.PrintRange = prPageNums then // [߰ގw]׼޵݂I
        PrintPageText(P,
                      InfoList1.TagStr,
                      RichEdit1.Font,
                      TabSize,
                      Parameter1['LineNumber'],
                      Parameter1['PILeftMargin'],
                      Parameter1['PIRightMargin'],
                      Parameter1['PITopMargin'],
                      Parameter1['PIBottomMargin'],
                      Parameter1['Partition'],
                      Parameter1['PartitionGap'],
                      Parameter1['PrintOption'],
                      RichEdit1.Font,
                      PrintDialog1.FromPage,
                      PrintDialog1.ToPage,
                      PrintDialog1.Copies)
      else if PrintDialog1.PrintRange = prSelection then // [I]׼޵݂I
      begin
        if RichEdit1.SelLength <> 0 then
          PrintText(RichEdit1.SelText,
                    InfoList1.TagStr,
                    RichEdit1.Font,
                    TabSize,
                    Parameter1['LineNumber'],
                    Parameter1['PILeftMargin'],
                    Parameter1['PIRightMargin'],
                    Parameter1['PITopMargin'],
                    Parameter1['PIBottomMargin'],
                    Parameter1['Partition'],
                    Parameter1['PartitionGap'],
                    Parameter1['PrintOption'],
                    RichEdit1.Font,
                    PrintDialog1.Copies);
      end;
    end;
  end;
end;

procedure TFrameForm.PrintSetup1Click(Sender: TObject);
begin
  PrinterSetupDialog1.Execute;
end;

procedure TFrameForm.Edit1Click(Sender: TObject);
begin
  if RichEdit1.CanUndo or UD.CanUndo then
    Undo1.Enabled := True
  else
    Undo1.Enabled := False;

  if RichEdit1.SelLength > 0 then
  begin
    Cut1.Enabled := True;
    Copy1.Enabled := True;
    Delete1.Enabled := True;
  end
  else
  begin
    Cut1.Enabled := False;
    Copy1.Enabled := False;
    Delete1.Enabled := False;
  end;

  if Clipboard.HasFormat(CF_TEXT) then
    P1.Enabled := True
  else
    P1.Enabled := False;

  if RichEdit1.Text <> '' then
    SelectAll1.Enabled := True
  else
    SelectAll1.Enabled := False;

  if EditMode = 0 then
  begin
    N17.Enabled := True;
    N18.Enabled := True;
  end
  else
  begin
    N17.Enabled := False;
    N18.Enabled := False;
  end;

  if RichEdit1.WordWrap then
    W1.Checked := True
  else
    W1.Checked := False;

  if Indent then
    I1.Checked := True
  else
    I1.Checked := False;
end;

procedure TFrameForm.Undo1Click(Sender: TObject);
begin
  if RichEdit1.CanUndo then
  begin
    RichEDit1.Undo;
    RichEdit1.ClearUndo;
    if ChangeCount = 2 then
      RichEdit1.Modified := False;
    if UD.CanUndo then
      UD.Modified := RichEdit1.Modified;
  end;

  if UD.CanUndo then
  begin
    RichEdit1.SelStart := UD.ReSelStart;
    RichEdit1.SelText := UD.SelText;
    RichEdit1.SelStart := UD.SelStart;
    RichEdit1.ClearUndo; // AhEobt@NA[
    RichEdit1.Modified := UD.Modified;
    UD.CanUndo := False;
  end;

  ModifiedCheck;
  BinaryCheck;
  DispStatus;
end;

procedure TFrameForm.Cut1Click(Sender: TObject);
begin
  RichEdit1.CutToClipboard;
end;

procedure TFrameForm.Copy1Click(Sender: TObject);
begin
  RichEdit1.CopyToClipboard;
end;

procedure TFrameForm.P1Click(Sender: TObject);
begin
  RichEdit1.PasteFromClipboard;
  ModifiedCheck;
  BinaryCheck;
  DispStatus;
end;

procedure TFrameForm.Delete1Click(Sender: TObject);
begin
  RichEdit1.ClearSelection;
end;

procedure TFrameForm.SelectAll1Click(Sender: TObject);
begin
  if RichEdit1.Text <> '' then
  begin
    RichEdit1.SelectAll;
    DispStatus;
  end;
end;

procedure TFrameForm.D1Click(Sender: TObject);
begin
  RichEdit1.SelText := DateTimeToStr(Now);
end;

procedure TFrameForm.W1Click(Sender: TObject);
var
  ss, len, vs: Integer;
begin
  ss := RichEdit1.SelStart;
  len := RichEdit1.SelLength;
  vs := ViewTopSel; // r[GA̐擪̃̕Zʒu

  RichEdit1.WordWrap := not RichEdit1.WordWrap;
  GetBLines(BIndex); // BLines[] Ɋesi[Ă BIndex Ԃ̃ubN\

  SetViewTopSel(vs);
  RichEdit1.SelStart := ss;
  RichEdit1.SelLength := len;
  Parameter1.VBools['WordWrap'] := RichEdit1.WordWrap;
  DispStatus;
end;

procedure TFrameForm.About1Click(Sender: TObject);
begin
  ModifiedCheck;
  BinaryCheck;
  DispStatus;
  ShellAbout(Handle, PChar(Application.Title),
             #13#10 + 'oCiN  Version 4.5 CopyrighRich (C) 2014 ` 2023 seizo',
             Application.Icon.Handle);
end;

procedure TFrameForm.SearchforHelpOn1Click(Sender: TObject);
var
  FileName: TFileName;
begin
  FileName := ExtractFilePath(Application.ExeName) + 'ReadmeB.txt';
  ShellExecute(Handle, PChar('open'), PChar(FileName), Nil, Nil, SW_SHOW);
end;

procedure TFrameForm.Find2Click(Sender: TObject);
begin
  FindDialogBox1.Division := MatchCase;
  GetFindStr;
  FindDialogBox1.FindText := FindStr;
  FindDialogBox1.Execute;
end;

procedure TFrameForm.FindNext1Click(Sender: TObject);
begin
  Search(FindStr, True);
end;

procedure TFrameForm.Find1Click(Sender: TObject);
begin
  if FindStr <> '' then
  begin
    FindNext1.Enabled := True;
    N7.Enabled := True;
  end
  else
  begin
    FindNext1.Enabled := False;
    N7.Enabled := False;
  end;
end;

procedure TFrameForm.N7Click(Sender: TObject);
begin
  Search(FindStr, False);
end;

procedure TFrameForm.Search(S: String; Down: Boolean);
var
  FindPos, FL: Integer;
begin
  if S = '' then
    Exit;

  if (FoundPos = -1) and (OldDown = Down) and (FindStr = S) then
  begin
    if (Down = True) and (BIndex < RCount - 1) then
      GoNextBlock
    else if (Down = False) and (BIndex > 0) then
      GoLastBlock
    else
      Exit;
  end;

  { ݂̃J[\ʒu猟Jn܂B}
  { IĂꍇ́AꕶJnʒuړ܂B}

  OldDown := Down;
  FindStr := S;
  FindPos := RichEdit1.SelStart;
  if Down then
  begin
    if RichEdit1.SelLength <> 0 then
      Inc(FindPos);
    while True do
    begin
      FoundPos := PosI(S, RichEdit1.Text, FindPos + 1, MatchCase) - 1;
      if (FoundPos = -1)
       or (ByteTypeX(RichEdit1.Text, FoundPos + 1) <> mbTrailByte) then
        Break;
      FindPos := FoundPos + 1;
    end;
  end
  else
  begin
    if RichEdit1.SelLength <> 0 then
      Dec(FindPos);
    if FindPos > Length(RichEdit1.Text) - Length(S) then
      FindPos := Length(RichEdit1.Text) - Length(S);
    while True do
    begin
      FoundPos := RPosI(S, RichEdit1.Text, FindPos + 1, MatchCase) - 1;
      if (FoundPos = -1)
       or (ByteTypeX(RichEdit1.Text, FoundPos + 1) <> mbTrailByte) then
        Break;
      FindPos := FoundPos - 1;
    end;
  end;
  if FoundPos <> -1 then
  begin
    FL := RichEdit1.Perform(EM_LINEFROMCHAR, FoundPos, 0);
    SetViewTopLine(FL - (ViewLineCount div 2) + 1);
    RichEdit1.SelStart := FoundPos;
    RichEdit1.SelLength := Length(S);
  end;

  DispStatus;
  if CM.Str <> FindStr then
    CM.Str := FindStr;
end;

procedure TFrameForm.T1Click(Sender: TObject);
begin
  ModifiedCheck;
  BinaryCheck;

  if RCount > 1 then
  begin
    BIndex := 0;
    case EditMode of
      0: RichEdit1.Text := InfoList1.TextItems[BIndex];
      1: RichEdit1.Text := InfoList1.CrystalItems[BIndex];
      2: RichEdit1.Text := InfoList1.DumpItems[BIndex];
      3: RichEdit1.Text := InfoList1.BinaryItems[BIndex];
    end;
    RichEdit1.Modified := False;
  end;
  RichEdit1.SelStart := 0;
  RichEdit1.Perform(EM_SCROLLCARET, 0, 0);
  DispStatus;
end;

procedure TFrameForm.D2Click(Sender: TObject);
begin
  ModifiedCheck;
  BinaryCheck;

  if RCount > 1 then
  begin
    BIndex := RCount - 1;
    case EditMode of
      0: RichEdit1.Text := InfoList1.TextItems[BIndex];
      1: RichEdit1.Text := InfoList1.CrystalItems[BIndex];
      2: RichEdit1.Text := InfoList1.DumpItems[BIndex];
      3: RichEdit1.Text := InfoList1.BinaryItems[BIndex];
    end;
    RichEdit1.Modified := False;
  end;
  RichEdit1.SelStart := Length(RichEdit1.Text);
  RichEdit1.Perform(EM_SCROLLCARET, 0, 0);
  DispStatus;
end;

procedure TFrameForm.J1Click(Sender: TObject);
var
  i, j, r, row: Integer;
  jmp: String;
begin
  ModifiedCheck;
  BinaryCheck;
  BLines[BIndex] := LineCount; // JgubN̍sXVB
  jmp := Jump;
  if InputQuery('Wv', '\sԍ', jmp) = False then
    Exit;

  row := StrToIntDef(jmp, 0);
  r := 0;
  for i := 0 to RCount - 1 do
    r := r + BLines[i];

  if row < 1 then row := 1
  else if row > r then row := r;

  Jump := IntToStr(row);
  i := 0; j := 0;
  while (i < RCount) and (row > 0) do
  begin
    j := i;
    r := row;
    row := row - BLines[i];
    Inc(i);
  end;
  BIndex := j;

  case EditMode of
    0: RichEdit1.Text := InfoList1.TextItems[BIndex];
    1: RichEdit1.Text := InfoList1.CrystalItems[BIndex];
    2: RichEdit1.Text := InfoList1.DumpItems[BIndex];
    3: RichEdit1.Text := InfoList1.BinaryItems[BIndex];
  end;
  RichEdit1.Modified := False;
  SetViewTopLine(r);
  DispStatus;
end;

procedure TFrameForm.Replace1Click(Sender: TObject);
begin
  ReplaceDialogBox1.Division := MatchCase;
  GetFindStr;
  ReplaceDialogBox1.FindText := FindStr;
  ReplaceDialogBox1.ReplaceText := FindStr;
  ReplaceDialogBox1.Execute;
end;

procedure TFrameForm.N9Click(Sender: TObject);
var
  SS, VL: Int64;
  Len1, Len2: Int64;
begin
  if EditMode = 0 then
    Exit;

  ModifiedCheck;
  BinaryCheck;
  Len1 := Length(RichEdit1.Text); // Old Len
  VL := ViewTopSel; // r[GA̐擪̃̕Zʒu
  SS := RichEdit1.SelStart; // J[\̃Zʒu

  EditMode := 0; // Text Mode
  StatusBar1.Panels[4].Text := '÷Ӱ';
  GetBLines(BIndex); // BLines[] Ɋesi[Ă BIndex Ԃ̃ubN\

  Len2 := Length(RichEdit1.Text); // New Len
  if (Len1 <> 0) and (Len2 <> 0) then
  begin
    VL := VL * Len2 div Len1;
    SS := SS * Len2 div Len1;
    SetViewTopSel(VL);
    RichEdit1.SelStart := SS;
  end;
  RichEdit1.Modified := False;
  DispStatus;
end;

procedure TFrameForm.N10Click(Sender: TObject);
var
  SS, VL: Int64;
  Len1, Len2: Int64;
begin
  if EditMode = 3 then
    Exit;

  ModifiedCheck;
  BinaryCheck;
  Len1 := Length(RichEdit1.Text); // Old Len
  VL := ViewTopLine; // r[GA̐擪̃̕Zʒu
  SS := RichEdit1.SelStart; // J[\̃Zʒu

  EditMode := 3; // Binary Mode
  StatusBar1.Panels[4].Text := '޲Ӱ';
  GetBLines(BIndex); // BLines[] Ɋesi[Ă BIndex Ԃ̃ubN\

  Len2 := Length(RichEdit1.Text); // New Len
  if (Len1 <> 0) and (Len2 <> 0) then
  begin
    VL := VL * Len2 div Len1;
    SS := SS * Len2 div Len1;
    SetViewTopLine(VL);
    RichEdit1.SelStart := SS;
  end;
  RichEdit1.Modified := False;
  DispStatus;
end;

procedure TFrameForm.F2Click(Sender: TObject);
var
  Mf: Boolean;
begin
  FontDialog1.Font := RichEdit1.Font;
  if FontDialog1.Execute then
  begin
    Mf := RichEdit1.Modified;
    RichEdit1.Font := FontDialog1.Font;
    Parameter1.VStrings['FontName'] := FontDialog1.Font.Name;
    Parameter1['FontSize'] := FontDialog1.Font.Size;
    Parameter1.VFontStyles['FontStyle'] := FontDialog1.Font.Style;
    Parameter1['FontColor'] := FontDialog1.Font.Color;
    Parameter1.SaveToFile; // sȂݒۑB
    RichEdit1.Modified := Mf;
  end;
end;

procedure TFrameForm.Option1Click(Sender: TObject);
begin
  if EditMode = 0 then // Text Mode
  begin
    N9.Checked := True;
    N9.Enabled := False;
    C1.Checked := False;
    C1.Enabled := True;
    D3.Checked := False;
    D3.Enabled := True;
    N10.Checked := False;
    N10.Enabled := True;
  end
  else if EditMode = 1 then // Crystal Mode
  begin
    N9.Checked := False;
    N9.Enabled := True;
    C1.Checked := True;
    C1.Enabled := False;
    D3.Checked := False;
    D3.Enabled := True;
    N10.Checked := False;
    N10.Enabled := True;
  end
  else if EditMode = 2 then // Dump Mode
  begin
    N9.Checked := False;
    N9.Enabled := True;
    C1.Checked := False;
    C1.Enabled := True;
    D3.Checked := True;
    D3.Enabled := False;
    N10.Checked := False;
    N10.Enabled := True;
  end
  else if EditMode = 3 then // Binary Mode
  begin
    N9.Checked := False;
    N9.Enabled := True;
    C1.Checked := False;
    C1.Enabled := True;
    D3.Checked := False;
    D3.Enabled := True;
    N10.Checked := True;
    N10.Enabled := False;
  end;
end;

procedure TFrameForm.PrintPreview1Click(Sender: TObject);
begin
  if RichEdit1.Text <> '' then
  begin
    PreviewForm := TPreviewForm.Create(Self);
    PreviewForm.ShowModal;
    PreviewForm.Free;
  end;
end;

procedure TFrameForm.FormCreate(Sender: TObject);
begin
  { tH[ւ̃hbOhbvB}
  DragAcceptFiles(Handle, True);
  Application.OnIdle := IdleHandler;
  Application.OnActivate := ActivateHandler;
  Application.HookMainWindow(Hook);
  { '_seizo8086_' ƂO 1KByte ̋L쐬 }
  CM := TCommonMemory.Create('_seizo8086_', 1024);
  FindStr := '';
end;

procedure TFrameForm.P3Click(Sender: TObject);
begin
  PreviewForm := TPreviewForm.Create(Self);
  PreviewForm.Caption := '';
  PreviewForm.ShowModal;
  PreviewForm.Free;
end;

procedure TFrameForm.S1Click(Sender: TObject);
begin
  SettingForm := TSettingForm.Create(Self);
  SettingForm.ShowModal;
  SettingForm.Free;
end;

procedure TFrameForm.C1Click(Sender: TObject);
var
  SS, VL: Int64;
  Len1, Len2: Int64;
begin
  if EditMode = 1 then
    Exit;

  ModifiedCheck;
  BinaryCheck;
  Len1 := Length(RichEdit1.Text); // Old Len
  VL := ViewTopSel; // r[GA̐擪̃̕Zʒu
  SS := RichEdit1.SelStart; // J[\̃Zʒu

  EditMode := 1; // Crystal Mode
  StatusBar1.Panels[4].Text := 'ؽӰ';
  GetBLines(BIndex); // BLines[] Ɋesi[Ă BIndex Ԃ̃ubN\

  Len2 := Length(RichEdit1.Text); // New Len
  if (Len1 <> 0) and (Len2 <> 0) then
  begin
    VL := VL * Len2 div Len1;
    SS := SS * Len2 div Len1;
    SetViewTopSel(VL);
    RichEdit1.SelStart := SS;
  end;
  RichEdit1.Modified := False;
  DispStatus;
end;

procedure TFrameForm.D3Click(Sender: TObject);
var
  SS, VL: Int64;
  Len1, Len2: Int64;
begin
  if EditMode = 2 then
    Exit;

  ModifiedCheck;
  BinaryCheck;
  Len1 := Length(RichEdit1.Text); // Old Len
  VL := ViewTopSel; // r[GA̐擪̃̕Zʒu
  SS := RichEdit1.SelStart; // J[\̃Zʒu

  EditMode := 2; // Dump Mode
  StatusBar1.Panels[4].Text := 'Ӱ';
  GetBLines(BIndex); // BLines[] Ɋesi[Ă BIndex Ԃ̃ubN\

  Len2 := Length(RichEdit1.Text); // New Len
  if (Len1 <> 0) and (Len2 <> 0) then
  begin
    VL := VL * Len2 div Len1;
    SS := SS * Len2 div Len1;
    SetViewTopSel(VL);
    RichEdit1.SelStart := SS;
  end;
  RichEdit1.Modified := False;
  DispStatus;
end;

procedure TFrameForm.N11Click(Sender: TObject);
var
  ss, len, vs: Integer;
begin
  ss := RichEdit1.SelStart;
  len := RichEdit1.SelLength;
  vs := ViewTopSel; // r[GA̐擪̃̕Zʒu

  RemakeData(BIndex); // f[^č\zĂ BIndex Ԃ̃ubN\

  SetViewTopSel(vs);
  RichEdit1.SelStart := ss;
  RichEdit1.SelLength := len;
  DispStatus;
end;

procedure TFrameForm.RichEdit1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  DispStatus;
end;

procedure TFrameForm.RichEdit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  SS, Len: Integer;
  P: PChar;
begin
  DownCY := CY;
  if ssCtrl in Shift then
  begin
    if Key = Word('Y') then
    begin // ݂̍s폜B
      RichEdit1.SelLength := 0;
      SS := RichEdit1.Perform(EM_LINEINDEX, DownCY - 1, 0);
      Len := RichEdit1.Perform(EM_LINEINDEX, DownCY, 0);
      if Len = -1 then Len := Length(RichEdit1.Text);
      Len := Len - SS;
      if Len > 0 then
      begin
        UD.Modified := RichEdit1.Modified;
        UD.SelStart := RichEdit1.SelStart;
        UD.ReSelStart := SS;

        RichEdit1.SelStart := SS;
        RichEdit1.SelLength := Len;

        UD.SelText := RichEdit1.SelText;

        RichEdit1.SelText := '';
        RichEdit1.ClearUndo; // AhEobt@NA[

        UD.CanUndo := True;
        Dec(ChangeCount);
      end;
    end
    else if Key = Word('S') then // s̐擪փJ[\ړB
      RichEdit1.SelStart := RichEdit1.Perform(EM_LINEINDEX, DownCY - 1, 0)
    else if Key = Word('K') then // s̖փJ[\ړB
    begin
      RichEdit1.SelLength := 0;
      SS := RichEdit1.Perform(EM_LINEINDEX, DownCY - 1, 0);
      Len := RichEdit1.Perform(EM_LINELENGTH, SS, 0);
      if Len > 0 then
      begin
        SS := SS + Len;
        P := PChar(RichEdit1.Text);
        if not (P[SS] in [#13, #10]) then
          Dec(SS);
        RichEdit1.SelStart := SS;
      end;
    end
    else if Key = Word('U') then
    begin // s̐擪J[\ʒu̎O܂ł̕폜B
      RichEdit1.SelLength := 0;
      SS := RichEdit1.Perform(EM_LINEINDEX, DownCY - 1, 0);
      Len := RichEdit1.SelStart - SS;
      if Len > 0 then
      begin
        UD.Modified := RichEdit1.Modified;
        UD.SelStart := RichEdit1.SelStart;
        UD.ReSelStart := SS;

        RichEdit1.SelStart := SS;
        RichEdit1.SelLength := Len;

        UD.SelText := RichEdit1.SelText;

        RichEdit1.SelText := '';
        RichEdit1.ClearUndo; // AhEobt@NA[

        UD.CanUndo := True;
        Dec(ChangeCount);
      end;
    end
    else if Key = Word('W') then
    begin // J[\ʒus̖܂ł̕폜B
      RichEdit1.SelLength := 0;
      SS := RichEdit1.Perform(EM_LINEINDEX, DownCY - 1, 0);
      Len := RichEdit1.SelStart - SS;
      Len := RichEdit1.Perform(EM_LINELENGTH, SS, 0) - Len;
      if Len > 0 then
      begin
        UD.Modified := RichEdit1.Modified;
        UD.SelStart := RichEdit1.SelStart;
        UD.ReSelStart := RichEdit1.SelStart;

        RichEdit1.SelLength := Len;

        UD.SelText := RichEdit1.SelText;

        RichEdit1.SelText := '';
        RichEdit1.ClearUndo; // AhEobt@NA[

        UD.CanUndo := True;
        Dec(ChangeCount);
      end;
    end;
  end
  else if Shift * [ssShift, ssAlt, ssCtrl] = [] then
  begin
    if (Key = VK_RETURN) and (EditMode = 0) and Indent then
      RichEdit1.Tag := 13
    else if Key = VK_INSERT then
    begin
      InsertMode := not InsertMode; // ۂ̓̓[hςB
      if InsertMode = True then
        StatusBar1.Panels[3].Text := '}'
      else
        StatusBar1.Panels[3].Text := '㏑';
    end;
  end;
end;

procedure TFrameForm.FindDialogBox1Find(Sender: TObject);
begin
  Search(FindDialogBox1.FindText, FindDialogBox1.Direction);
  MatchCase := FindDialogBox1.Division;
  FindStr := FindDialogBox1.FindText;
end;

procedure TFrameForm.FindDialogBox1ChangeDivision(Sender: TObject);
begin
  FoundPos := RichEdit1.SelStart;
  // RichEdit1.SelLength := 0;
end;

procedure TFrameForm.FindDialogBox1ChangeDirection(Sender: TObject);
begin
  FoundPos := RichEdit1.SelStart;
  // RichEdit1.SelLength := 0;
end;

procedure TFrameForm.FindDialogBox1ChangeFindText(Sender: TObject);
begin
  FoundPos := RichEdit1.SelStart;
  // RichEdit1.SelLength := 0;
end;

procedure TFrameForm.FindDialogBox1Show(Sender: TObject);
begin
  ReplaceDialogBox1.Close;
end;

procedure TFrameForm.FormDestroy(Sender: TObject);
begin
  { '_seizo8086_' ƂŐL }
  CM.Free;
  Application.UnhookMainWindow(Hook);
end;

procedure TFrameForm.ReplaceDialogBox1ChangeDirection(Sender: TObject);
begin
  FoundPos := RichEdit1.SelStart;
  // RichEdit1.SelLength := 0;
end;

procedure TFrameForm.ReplaceDialogBox1ChangeDivision(Sender: TObject);
begin
  FoundPos := RichEdit1.SelStart;
  // RichEdit1.SelLength := 0;
end;

procedure TFrameForm.ReplaceDialogBox1ChangeFindText(Sender: TObject);
begin
  FoundPos := RichEdit1.SelStart;
  // RichEdit1.SelLength := 0;
end;

procedure TFrameForm.ReplaceDialogBox1Find(Sender: TObject);
begin
  Search(ReplaceDialogBox1.FindText, ReplaceDialogBox1.Direction);
  MatchCase := ReplaceDialogBox1.Division;
  FindStr := ReplaceDialogBox1.FindText;
end;

procedure TFrameForm.ReplaceDialogBox1ReplaceFind(Sender: TObject);
begin
  ReplaceOne(ReplaceDialogBox1.FindText, ReplaceDialogBox1.ReplaceText, MatchCase);
  if ReplaceDialogBox1.Direction = False then
    RichEdit1.SelStart := RichEdit1.SelStart - Length(ReplaceDialogBox1.ReplaceText);
  Search(ReplaceDialogBox1.FindText, ReplaceDialogBox1.Direction);
  MatchCase := ReplaceDialogBox1.Division;
  FindStr := ReplaceDialogBox1.FindText;
end;

procedure TFrameForm.ReplaceDialogBox1ReplaceAll(Sender: TObject);
var
  Count: Integer;
begin
  if RichEdit1.SelLength <= Length(ReplaceDialogBox1.FindText) then
    RichEdit1.SelLength := 0;

  if RichEdit1.SelLength > 0 then
    Count := ReplaceSel(ReplaceDialogBox1.FindText, ReplaceDialogBox1.ReplaceText, MatchCase)
  else
    Count := ReplaceAll(ReplaceDialogBox1.FindText, ReplaceDialogBox1.ReplaceText, MatchCase);
  StatusBar1.Panels[4].Text := IntToStr(Count) + ' u';
  MatchCase := ReplaceDialogBox1.Division;
  FindStr := ReplaceDialogBox1.FindText;
end;

procedure TFrameForm.ReplaceDialogBox1Show(Sender: TObject);
begin
  FindDialogBox1.Close;
end;

procedure TFrameForm.FormResize(Sender: TObject);
var
  ss, len, vs: Integer;
begin
  ss := RichEdit1.SelStart;
  len := RichEdit1.SelLength;
  vs := ViewTopSel; // r[GA̐擪̃̕Zʒu

  ModifiedCheck;
  BinaryCheck;
  GetBLines(BIndex); // BLines[] Ɋesi[Ă BIndex Ԃ̃ubN\

  SetViewTopSel(vs);
  RichEdit1.SelStart := ss;
  RichEdit1.SelLength := len;
  DispStatus;
end;

procedure TFrameForm.RichEdit1Change(Sender: TObject);
begin
  Inc(ChangeCount); // ύXꂽ

  if RichEdit1.Tag = 13 then
  begin
    RichEdit1.Tag := 0;
    RichEdit1.SelText := IndentStr(DownCY); // 1sÕCfg
  end;
end;

procedure TFrameForm.RichEdit1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Shift * [ssShift, ssAlt, ssCtrl] = [] then
  begin
    if (Key in [VK_UP, VK_PRIOR]) and (DownCY = 1) and
            (RCount > 1) and  (BIndex > 0) then
      GoLastBlock
    else if (Key in [VK_DOWN, VK_NEXT]) and (DownCY = LineCount) and
            (RCount > 1) and (BIndex < RCount - 1) then
      GoNextBlock;
  end;
  DispStatus;
end;

procedure TFrameForm.I1Click(Sender: TObject);
begin
  Indent := not Indent;
end;

procedure TFrameForm.Q1Click(Sender: TObject);
begin
  WindowState := wsNormal;
  ClientWidth := 693;
  ClientHeight := 446;
end;

procedure TFrameForm.N15Click(Sender: TObject);
begin
  if KeyForm.Visible then
    KeyForm.Close
  else
  begin
    KeyForm.Show;
    SetFocus;
  end;
end;

procedure TFrameForm.Help1Click(Sender: TObject);
begin
  if KeyForm.Visible then
    N15.Checked := True
  else
    N15.Checked := False;
end;

procedure TFrameForm.N17Click(Sender: TObject);
var
  bc, bi, vl: Integer;
  S, N: String;
begin
  bc := BCount;
  bi := BIndex;
  vl := ViewTopLine; // r[GA̐擪̍s
  BCount := 0; // f[^1̃ubNɂ܂Ƃ߂B
  BIndex := 0; // 擪̃ubN
  RemakeData(BIndex); // f[^č\zB
  S := InfoList1.TextItems[BIndex];
  N := Tab2Space(S, TabSize);
  InfoList1.TextItems[BIndex] := N;
  BCount := bc; // Ƃɖ߂B
  BIndex := bi; // Ƃɖ߂B
  RemakeData(BIndex); // f[^č\zB
  SetViewTopLine(vl);
  Modified := True;
  RichEdit1.Modified := False;
end;

procedure TFrameForm.N18Click(Sender: TObject);
var
  bc, bi, vl: Integer;
  S, N: String;
begin
  bc := BCount;
  bi := BIndex;
  vl := ViewTopLine; // r[GA̐擪̍s
  BCount := 0; // f[^1̃ubNɂ܂Ƃ߂B
  BIndex := 0; // 擪̃ubN
  RemakeData(BIndex); // f[^č\zB
  S := InfoList1.TextItems[BIndex];
  N := Space2Tab(S, TabSize);
  InfoList1.TextItems[BIndex] := N;
  BCount := bc; // Ƃɖ߂B
  BIndex := bi; // Ƃɖ߂B
  RemakeData(BIndex); // f[^č\zB
  SetViewTopLine(vl);
  Modified := True;
  RichEdit1.Modified := False;
end;

procedure TFrameForm.N20Click(Sender: TObject);
var
  Dir: String;
begin
  Dir := ExtractFilePath(Application.ExeName) + 'Backup';
  ShellExecute(Handle, PChar('open'), PChar(Dir), Nil, Nil, SW_SHOW);
end;

end.
